summaryrefslogtreecommitdiffstats
path: root/scripts/meson-vcs-tag.sh
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/meson-vcs-tag.sh')
-rwxr-xr-xscripts/meson-vcs-tag.sh17
1 files changed, 17 insertions, 0 deletions
diff --git a/scripts/meson-vcs-tag.sh b/scripts/meson-vcs-tag.sh
new file mode 100755
index 0000000..8ce6924
--- /dev/null
+++ b/scripts/meson-vcs-tag.sh
@@ -0,0 +1,17 @@
+#!/usr/bin/env bash
+# SPDX-License-Identifier: LGPL-2.1-or-later
+
+set -eu
+set -o pipefail
+
+dir="${1:?}"
+fallback="${2:?}"
+
+# Apparently git describe has a bug where it always considers the work-tree
+# dirty when invoked with --git-dir (even though 'git status' is happy). Work
+# around this issue by cd-ing to the source directory.
+cd "$dir"
+# Check that we have either .git/ (a normal clone) or a .git file (a work-tree)
+# and that we don't get confused if a tarball is extracted in a higher-level
+# git repository.
+[ -e .git ] && git describe --abbrev=7 --dirty=+ 2>/dev/null | sed 's/^v//' || echo "$fallback"